/**
 * jQuery lightBox plugin
 * This jQuery plugin was inspired and based on Lightbox 2 by Lokesh Dhakar (http://www.huddletogether.com/projects/lightbox2/)
 * and adapted to me for use like a plugin from jQuery.
 * @name jquery-lightbox-0.5.js
 * @author Leandro Vieira Pinho - http://leandrovieira.com
 * @version 0.5
 * @date April 11, 2008
 * @category jQuery plugin
 * @copyright (c) 2008 Leandro Vieira Pinho (leandrovieira.com)
 * @license CC Attribution-No Derivative Works 2.5 Brazil - http://creativecommons.org/licenses/by-nd/2.5/br/deed.en_US
 * @example Visit http://leandrovieira.com/projects/jquery/lightbox/ for more informations about this jQuery plugin
 */
(function($) {
	$.fn.lightBox = function(settings) {
		settings = jQuery.extend({
			overlayBgColor: 		'#000',
			overlayOpacity:			0.8,
			fixedNavigation:		false,
            showIndex:              false,
            playInterval:           3000,
			imageLoading:			'/images/lightbox-ico-loading.gif',
			imageBtnClose:			'/images/lightbox-btn-close.gif',
			imageBlank:				'/images/lightbox-blank.gif',
			containerBorderSize:	10,
			containerResizeSpeed:	400,
			txtImage:				'Изображение',
			txtOf:					'из',
			keyToClose:				'закрыть',
			keyToPrev:				'p',
			keyToNext:				'n',
			imageArray:				[],
			activeImage:			0
		},settings);
		var jQueryMatchedObj = this;
        var isPlaying = false;

		function _initialize() {
			_start(this,jQueryMatchedObj);
			return false;
		}

		function _start(objClicked,jQueryMatchedObj) {
			$('embed, object, select').css({ 'visibility' : 'hidden' });
			_set_interface();
			settings.imageArray.length = 0;
			settings.activeImage = 0;
            var imgString = 'dyn_images/img.html';
            var bigSource = 'dyn_images/expose/big.html';
			if ( jQueryMatchedObj.length == 1 ) {
                if (objClicked.tagName == 'AREA') {
                    settings.imageArray.push(new Array(bigSource.replace(/\%/, objClicked.getAttribute('image')), objClicked.getAttribute('alt')));
                } else {
                    settings.imageArray.push(new Array(objClicked.getAttribute('href'), objClicked.getAttribute('title'), $(objClicked).children('.date').text(), $(objClicked).children('.desc').text()));
                }
			} else {
				for (var i=0; i<jQueryMatchedObj.length; i++) {
                    if (jQueryMatchedObj[i].tagName == 'AREA') {
                        settings.imageArray.push(new Array('/dyn_images/img'+jQueryMatchedObj[i].getAttribute('image')+'.jpg', jQueryMatchedObj[i].getAttribute('alt')));
                    } else {
                        settings.imageArray.push(new Array(jQueryMatchedObj[i].getAttribute('href'), jQueryMatchedObj[i].getAttribute('title'), $(jQueryMatchedObj[i]).children('.date').text(), $(jQueryMatchedObj[i]).children('.desc').text()));
                    }
				}
			}
            var href = objClicked.getAttribute('href');
            href = (objClicked.tagName == 'AREA') ? bigSource.replace(/\%/, objClicked.getAttribute('image')) : href;
			while (settings.imageArray[settings.activeImage][0] != href) {
				settings.activeImage++;
			}
			_set_image_to_view();
		}

		function _set_interface() {
			$('body').append('<div id="jquery-overlay"></div>'
                            +'<div id="jquery-lightbox"><div id="lightbox-container-image-box">'
                            +'<div id="lightbox-container-image"><img id="lightbox-image"/>'
                                +'<div style="display:none" id="lightbox-nav"><ul><li id="lightbox-nav-btnPrev"></li><li id="lightbox-nav-btnPlay"></li><li id="lightbox-nav-btnPause"></li><li id="lightbox-nav-btnNext"></li><li id="lightbox-nav-btnClose"></li></ul></div>'
                                +'<div id="lightbox-loading"><a href="#" id="lightbox-loading-link"><img src="' + settings.imageLoading + '"></a></div>'
                                +'<div id="lightbox-secNav"><a href="#" id="lightbox-secNav-btnClose"><img src="' + settings.imageBtnClose + '"></a></div>'
                            +'</div></div>'
                            +'<div id="lightbox-container-image-data-box"><div id="lightbox-container-image-data">'
                                +'<div id="lightbox-image-details"><span id="lightbox-image-details-date"></span><span id="lightbox-image-details-caption"></span><span id="lightbox-image-details-desc"></span><span id="lightbox-image-details-currentNumber"></span></div>'
                            +'</div></div></div>');
			var arrPageSizes = ___getPageSize();
			$('#jquery-overlay').css({
				backgroundColor:	settings.overlayBgColor,
				opacity:			settings.overlayOpacity,
				width:				arrPageSizes[0],
				height:				arrPageSizes[1]
			}).fadeIn();
			var arrPageScroll = ___getPageScroll();
			$('#jquery-lightbox').css({
				top:	arrPageScroll[1] + (arrPageSizes[3] / 10),
				left:	arrPageScroll[0]
			}).show();
			$('#jquery-overlay,#jquery-lightbox').click(function() {
				_finish();									
			});
			$('#lightbox-loading-link,#lightbox-nav-btnClose,#lightbox-secNav-btnClose').click(function() {
				_finish();
				return false;
			});
			$(window).resize(function() {
				var arrPageSizes = ___getPageSize();
				$('#jquery-overlay').css({
					width:		arrPageSizes[0],
					height:		arrPageSizes[1]
				});
				var arrPageScroll = ___getPageScroll();
				$('#jquery-lightbox').css({
					top:	arrPageScroll[1] + (arrPageSizes[3] / 10),
					left:	arrPageScroll[0]
				});
			});
		}
		/**
		 * Prepares image exibition; doing a image?s preloader to calculate it?s size
		 */
		function _set_image_to_view() {
			$('#lightbox-loading').show();
            $('#lightbox-image,#lightbox-nav,#lightbox-container-image-data-box,#lightbox-image-details-currentNumber').hide();
			var objImagePreloader = new Image();
			objImagePreloader.onload = function(){
				$('#lightbox-image').attr('src', settings.imageArray[settings.activeImage][0]);
				_resize_container_image_box(objImagePreloader.width,objImagePreloader.height);
				objImagePreloader.onload=function(){};
			};
			objImagePreloader.src = settings.imageArray[settings.activeImage][0];
		};
		/**
		 * Perfomance an effect in the image container resizing it
		 */
		function _resize_container_image_box(intImageWidth,intImageHeight) {
			var intCurrentWidth = $('#lightbox-container-image-box').width();
			var intCurrentHeight = $('#lightbox-container-image-box').height();
			var intWidth = (intImageWidth + (settings.containerBorderSize * 2));
			var intHeight = (intImageHeight + (settings.containerBorderSize * 2));
			var intDiffW = intCurrentWidth - intWidth;
			var intDiffH = intCurrentHeight - intHeight;
			$('#lightbox-container-image-box').animate({ width: intWidth, height: intHeight },settings.containerResizeSpeed,function() { _show_image(); });
			if ( ( intDiffW == 0 ) && ( intDiffH == 0 ) ) {
				if ( $.browser.msie ) {
					___pause(250);
				} else {
					___pause(100);	
				}
			}
			$('#lightbox-container-image-data-box').css({ width: intImageWidth });
		};
		/**
		 * Show the prepared image
		 */
		function _show_image() {
			$('#lightbox-loading').hide();
			$('#lightbox-image').fadeIn(function() {
				_show_image_data();
				_set_navigation();
			});
			_preload_neighbor_images();
		};
		/**
		 * Show the image information
		 */
		function _show_image_data() {
			$('#lightbox-image-details-caption, #lightbox-image-details-date, #lightbox-image-details-desc').hide();
            $('#lightbox-image-details>span').html('');
			if ( settings.imageArray[settings.activeImage][1] ) {
				$('#lightbox-image-details-caption').html(settings.imageArray[settings.activeImage][1]).show();
			}
			if ( settings.imageArray[settings.activeImage].length > 2 ) {
                if (settings.imageArray[settings.activeImage][2] != '') {
                    $('#lightbox-image-details-date').html(settings.imageArray[settings.activeImage][2]).show();
                }
                if (settings.imageArray[settings.activeImage][3] != '') {
                    $('#lightbox-image-details-desc').html(settings.imageArray[settings.activeImage][3]).show();
                }
            }
			if (settings.showIndex && settings.imageArray.length>1) {
				$('#lightbox-image-details-currentNumber').html(settings.txtImage + ' ' + ( settings.activeImage + 1 ) + ' ' + settings.txtOf + ' ' + settings.imageArray.length).show();
			}
            if ($('#lightbox-image-details>span').not(':empty').size() > 0) {
                $('#lightbox-container-image-data-box').slideDown('fast');
            }
		}
		/**
		 * Display the button navigations
		 */
		function _set_navigation() {
            $('#lightbox-nav-btnPrev,#lightbox-nav-btnNext').removeClass('disable').unbind();
            // prev button
			if (settings.activeImage != 0) {
                $('#lightbox-nav-btnPrev').bind('click',function() {
                    $('#lightbox-nav-btnPause').trigger('click');
                    settings.activeImage = settings.activeImage - 1;
                    _set_image_to_view();
                    return false;
                });
            } else {
                $('#lightbox-nav-btnPrev').addClass('disable').bind('click',function(){ return false; });
            }
            // next button
			if (settings.activeImage != (settings.imageArray.length-1)) {
                $('#lightbox-nav-btnNext').bind('click',function() {
                    $('#lightbox-nav-btnPause').trigger('click');
                    settings.activeImage = settings.activeImage + 1;
                    _set_image_to_view();
                    return false;
                });
            } else {
                $('#lightbox-nav-btnNext').addClass('disable').bind('click',function(){ return false; });
            }
            // play/pause buttons
            $('#lightbox-nav-btnPause').bind('click',function(){
                if (!isPlaying) { return false; }
                isPlaying = false;
                $('#lightbox-nav-btnPlay').removeClass('disable');
                $('#lightbox-nav-btnPause').addClass('disable');
                $('#lightbox-nav').stopTime('lightboxSlideshow');
                return false;
            });
            $('#lightbox-nav-btnPlay').bind('click',function(){
                if (isPlaying) { return false; }
                isPlaying = true;
                $('#lightbox-nav-btnPlay').addClass('disable');
                $('#lightbox-nav-btnPause').removeClass('disable');
                $('#lightbox-nav').everyTime(settings.playInterval, 'lightboxSlideshow', function(i){
                    if (settings.activeImage == (settings.imageArray.length-1)) {
                        settings.activeImage = 0;
                    } else {
                        settings.activeImage = settings.activeImage + 1;
                    }
                    _set_image_to_view();
                });
                return false;
            });
            if (isPlaying) {
                $('#lightbox-nav-btnPlay').addClass('disable');
            } else {
                $('#lightbox-nav-btnPause').addClass('disable');
            }
            // when to show controls
            if (settings.imageArray.length > 0) {
                $('#lightbox-nav').css({opacity:0.0}).show();
                if ( settings.fixedNavigation ) {
                    $('#lightbox-nav').fadeTo('medium',0.8);
                } else {
                    $('#lightbox-container-image').mouseenter(function(){
                        $('#lightbox-nav').fadeTo('medium',0.8);
                    }).mouseleave(function(){
                        $('#lightbox-nav').fadeTo('medium',0.0);
                    });
                    $('#lightbox-container-image').mouseover();
                }
            }
			_enable_keyboard_navigation();
		}
		/**
		 * Enable a support to keyboard navigation
		 */
		function _enable_keyboard_navigation() {
			$(document).keydown(function(objEvent) {
				_keyboard_action(objEvent);
			});
		}
		/**
		 * Disable the support to keyboard navigation
		 */
		function _disable_keyboard_navigation() {
			$(document).unbind();
		}
		/**
		 * Perform the keyboard actions
		 */
		function _keyboard_action(objEvent) {
			if ( objEvent == null ) {
				keycode = event.keyCode;
				escapeKey = 27;
			} else {
				keycode = objEvent.keyCode;
				escapeKey = objEvent.DOM_VK_ESCAPE;
			}
			key = String.fromCharCode(keycode).toLowerCase();
			if ( ( key == settings.keyToClose ) || ( key == 'x' ) || ( keycode == escapeKey ) ) {
				_finish();
			}
			if ( ( key == settings.keyToPrev ) || ( keycode == 37 ) ) {
				if ( settings.activeImage != 0 ) {
					settings.activeImage = settings.activeImage - 1;
					_set_image_to_view();
					_disable_keyboard_navigation();
				}
			}
			if ( ( key == settings.keyToNext ) || ( keycode == 39 ) ) {
				if ( settings.activeImage != ( settings.imageArray.length - 1 ) ) {
					settings.activeImage = settings.activeImage + 1;
					_set_image_to_view();
					_disable_keyboard_navigation();
				}
			}
		}
		/**
		 * Preload prev and next images being showed
		 */
		function _preload_neighbor_images() {
			if ( (settings.imageArray.length -1) > settings.activeImage ) {
				objNext = new Image();
				objNext.src = settings.imageArray[settings.activeImage + 1][0];
			}
			if ( settings.activeImage > 0 ) {
				objPrev = new Image();
				objPrev.src = settings.imageArray[settings.activeImage -1][0];
			}
		}
		/**
		 * Remove jQuery lightBox plugin HTML markup
		 */
		function _finish() {
            $('#lightbox-nav').stopTime('lightboxSlideshow');
            isPlaying = false;
			$('#jquery-lightbox').remove();
			$('#jquery-overlay').fadeOut(function() { $('#jquery-overlay').remove(); });
			$('embed, object, select').css({ 'visibility' : 'visible' });
		}
		/**
		 * getPageSize() by quirksmode.com
		 */
		function ___getPageSize() {
			var xScroll, yScroll;
			if (window.innerHeight && window.scrollMaxY) {	
				xScroll = window.innerWidth + window.scrollMaxX;
				yScroll = window.innerHeight + window.scrollMaxY;
			} else if (document.body.scrollHeight > document.body.offsetHeight){
				xScroll = document.body.scrollWidth;
				yScroll = document.body.scrollHeight;
			} else {
				xScroll = document.body.offsetWidth;
				yScroll = document.body.offsetHeight;
			}
			var windowWidth, windowHeight;
			if (self.innerHeight) {
				if(document.documentElement.clientWidth){
					windowWidth = document.documentElement.clientWidth;
				} else {
					windowWidth = self.innerWidth;
				}
				windowHeight = self.innerHeight;
			} else if (document.documentElement && document.documentElement.clientHeight) {
				windowWidth = document.documentElement.clientWidth;
				windowHeight = document.documentElement.clientHeight;
			} else if (document.body) {
				windowWidth = document.body.clientWidth;
				windowHeight = document.body.clientHeight;
			}	
			if(yScroll < windowHeight){
				pageHeight = windowHeight;
			} else {
				pageHeight = yScroll;
			}
			if(xScroll < windowWidth){	
				pageWidth = xScroll;		
			} else {
				pageWidth = windowWidth;
			}
			arrayPageSize = new Array(pageWidth,pageHeight,windowWidth,windowHeight);
			return arrayPageSize;
		};
		/**
		 * getPageScroll() by quirksmode.com
		 */
		function ___getPageScroll() {
			var xScroll, yScroll;
			if (self.pageYOffset) {
				yScroll = self.pageYOffset;
				xScroll = self.pageXOffset;
			} else if (document.documentElement && document.documentElement.scrollTop) {
				yScroll = document.documentElement.scrollTop;
				xScroll = document.documentElement.scrollLeft;
			} else if (document.body) {
				yScroll = document.body.scrollTop;
				xScroll = document.body.scrollLeft;	
			}
			arrayPageScroll = new Array(xScroll,yScroll);
			return arrayPageScroll;
		};
		 /**
		  * Stop the code execution from a escified time in milisecond
		  */
		 function ___pause(ms) {
			var date = new Date();
			curDate = null;
			do { var curDate = new Date(); }
			while ( curDate - date < ms);
		 };
         return this.unbind('click').click(_initialize);
	};
})(jQuery);

$(document).ready(function(){
    $('a.lightbox:has(img)').lightBox({fixedNavigation:false});
    var bigSource = 'dyn_images/expose/big.html';
    $('area[image]').each(function(){
        $.ajax({
            type: 'HEAD',
            url: bigSource.replace(/\%/, $(this).attr('image')),
            success: function(msg){
                var imgId = this.url.match(/\d+/)[0];
                if (imgId) {
                    $('area[image='+imgId+']').lightBox();
                }
            },
            error: function(msg){
                //console.log('Expose image DOSN\'T exists.');
            }
        });
    });
});